<template lang="pug">
.file.is-flex( v-if='file' )
	template( v-if='type == "image"' )
		.box.image
			.img.is-flex
				img( :src='file.bucket ? `https://media-bot.media.roybots.ru/storage/${file.bucket}/${file.src}` : stream(file)' )
	template( v-else )
		.box.is-flex.is-flex-direction-column.is-align-items-center.is-justify-content-center
			.icon.is-large.mb-3
				i.fa-solid.fa-file.fa-2x
			p.is-size-7.has-text-weight-bold.name {{ file.name || file.src }}
	span.close.icon( v-if='!noRemove' @click='emit("remove")' )
		i.fa-solid.fa-circle-xmark
</template>

<script setup>
const props = defineProps({
	file: [ File, Object ],
	type: {
		type: String,
		default: "image",
		validator: val => [ "image", "file" ].includes(val)
	},
	noRemove: Boolean
})

const emit = defineEmits([ "remove" ])

const stream = file => URL.createObjectURL(file)
</script>

<style lang="scss" scoped>
.file {
	max-width: 7rem;
	width: 7rem;
	position: relative;
	.box {
		width: 100%;
		height: 100%;
		padding: .25rem .125rem;
		margin-bottom: 0!important;
		&.image {
			padding: 0;
		}
	}
	.close {
		max-height: 1.5rem;
		max-width: 1.5rem;
		position: absolute;
		right: -.5rem;
		top: -.5rem;
		cursor: pointer;
	}
	.name {
		font-size: .75rem;
		text-align: center;
		word-break: break-all;
	}
}
</style>